/**
Templated dynamically allocated multidimensional arrays
**/

#include <iostream>

template <typename T>
T ** AllocateDynamicArray(int nRows, int nCols)
{
    T **dynamicArray;
    dynamicArray = new T *[nRows];

    for(int i = 0; i < nRows ; i++)
    {
        dynamicArray[i] = new T [nCols];
    }

    return dynamicArray;
}

template <typename T>
void FreeDynamicArray(T **dArray, int nRows)
{
    for(int i = 0; i < nRows; i++)
    {
        delete[] dArray[i];
    }

    delete[] dArray;
}

int main()
{
    int **my2dArr = AllocateDynamicArray<int>(4, 4);
    my2dArr[2][2] = 8;
    FreeDynamicArray<int>(my2dArr, 4);

    return 0;
}
