/**
Classes with dynamic members

If a your user-defined class with dynamically allocated members is to function in all typical ways, you need to to write its:
* Default constructor
* Parameterized constructor
* Copy constructor
* Assignment operator=
* Default destructor

We will be doing this all semester, so make sure to ask questions now!

Trace this in cgdb during class.
**/

#include <iostream>
using namespace std;
using std::cout;

class Rectangle
{
    private:
        int width, height, *fillDensity;

    public:
        // Parameterized constructor
        Rectangle(int, int, int);

        // new default constructor
        Rectangle();

        // copy constructor
        Rectangle(const Rectangle &);

         // assignment (overload operator, not constructor)
        Rectangle & operator=(const Rectangle &);

        // destructor
        ~Rectangle();

        int printFill(){return *fillDensity;}
};

Rectangle::Rectangle(int a, int b, int fillVal)
{
    width = a;
    height = b;
    fillDensity = new int(fillVal);
}

Rectangle::Rectangle()
{
    width = 5;
    height = 5;
    fillDensity = new int(255);
}

Rectangle::Rectangle(const Rectangle &source)
{
    width = source.width;
    height = source.height;

    // shallow copy pointer itself
    //fillDensity = source.fillDensity;

    // deep copy contents
    fillDensity = new int(*(source.fillDensity));
}

Rectangle & Rectangle::operator=(const Rectangle &rhs)
{
    if(this != &rhs)
    {
        width = rhs.width;
        height = rhs.height;

        // shallow copy pointer itself
        // fillDensity = rhs.fillDensity;

        // deep copy contents
        *fillDensity = *(rhs.fillDensity);

        // Allows chaining of operator= when called.
        return *this;
    }
}

// Ask: Why does the syntax for copy constructor and operator= differ?

Rectangle::~Rectangle()
{
    delete fillDensity;
    cout << "Destructor" << endl;
}

int main()
{
    // parameterized constructor
    Rectangle rect(3, 4, 253);

    // default constructor
    Rectangle recta;

    // copy constructor
    Rectangle rectb(rect);
    Rectangle rectc = rect;

    // operator= assignment
    // not constructor, but provided by defualt nonetheless
    recta = rect;

    // chaining of operator = with *this returned
    Rectangle rectd;
    rectd = recta = rect;

    Rectangle * pRect = new Rectangle;
    delete pRect;

    // How many times does the destructor execute?

    return 0;
}
